// dxdebug.h

#pragma comment(lib, "D3d8.lib")
#pragma comment(lib, "D3dx8.lib")
#include <d3dx8.h>

/*
inline void DebugDrawBox2D(IDirect3DDevice8* pD3DDevice, float x0, float y0, float x1, float y1)
{
	struct TLVERTEX
	{
		float x,y,z,rhw;
		float tu,tv;
		enum { FVF_TLVERTEX = D3DFVF_XYZRHW | D3DFVF_TEX1 };
	};

	pD3DDevice->SetTextureStageState(0,D3DTSS_COLOROP,	D3DTOP_SELECTARG1);
	pD3DDevice->SetTextureStageState(0,D3DTSS_COLORARG1,	D3DTA_TEXTURE);
	float scale = 128.0f;
	TLVERTEX Vertex[4] = 
	{
		// x		y   z rhw tu tv
		{    0,    0,	0, 1, 0, 0,},
		{scale,    0,	0, 1, 1, 0,},
		{scale,scale,	0, 1, 1, 1,},
		{    0,scale,	0, 1, 0, 1,},
	};
	pD3DDevice->SetTexture( 0, NULL );
	pD3DDevice->SetVertexShader( TLVERTEX::FVF_TLVERTEX );
	pD3DDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN, 2, Vertex, sizeof( TLVERTEX ) );
}
*/



inline void DebugWireDrawBox2D(IDirect3DDevice8* pD3DDevice, float x0, float y0, float w0, float h0)
{
	struct VERTEX
	{
		float x,y,z,rhw;
		unsigned int rgba;
		enum { FVF_VERTEX = D3DFVF_XYZRHW | D3DFVF_DIFFUSE };
	};

	pD3DDevice->SetTextureStageState(0,D3DTSS_COLOROP,	D3DTOP_SELECTARG1);
	pD3DDevice->SetTextureStageState(0,D3DTSS_COLORARG1,	D3DTA_DIFFUSE);
	VERTEX Vertex[5] = 
	{
		// x   y		z  rhw, colour
		{ x0,	y0,		0, 1,  0xff00ffff},
		{ x0+w0,y0,		0, 1,  0xff00ffff},
		{ x0+w0,y0+h0,	0, 1,  0xff00ffff},
		{ x0,	y0+h0,	0, 1,  0xff00ffff},
		{ x0,	y0,		0, 1,  0xff00ffff},
	};
	pD3DDevice->SetTexture( 0, NULL );
	pD3DDevice->SetVertexShader( VERTEX::FVF_VERTEX );
	pD3DDevice->DrawPrimitiveUP( D3DPT_LINESTRIP, 4, Vertex, sizeof( VERTEX ) );
}

inline void DebugDrawTexList2D(IDirect3DDevice8* pD3DDevice, IDirect3DTexture8* pTex,  D3DXVECTOR2* pPoints, D3DXVECTOR2* pTexPoints, int NumPoints, int depth,
							   float mulr, float mulg, float mulb, float mula,
							   int   addr, int   addg, int   addb, int   adda)
{
	struct TVERTEX
	{
		float x,y,z,rhw;
		DWORD colmul;
		DWORD coladd;
		float tu,tv;
		enum { FVF_TVERTEX = D3DFVF_XYZRHW | D3DFVF_DIFFUSE | D3DFVF_SPECULAR | D3DFVF_TEX1  };
	};


	// stage 1 coloring
	pD3DDevice->SetTextureStageState(0, D3DTSS_COLOROP,   D3DTOP_MODULATE);
	pD3DDevice->SetTextureStageState(0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
	pD3DDevice->SetTextureStageState(0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);

	pD3DDevice->SetTextureStageState(1, D3DTSS_COLOROP,  D3DTOP_ADD );
	pD3DDevice->SetTextureStageState(1, D3DTSS_COLORARG1,D3DTA_SPECULAR );
	pD3DDevice->SetTextureStageState(1, D3DTSS_COLORARG2,D3DTA_CURRENT );


	// 0
	pD3DDevice->SetTextureStageState(0, D3DTSS_ALPHAOP,  D3DTOP_MODULATE );
	pD3DDevice->SetTextureStageState(0, D3DTSS_ALPHAARG1,D3DTA_TEXTURE );
	pD3DDevice->SetTextureStageState(0, D3DTSS_ALPHAARG2,D3DTA_DIFFUSE );

	// 1
	pD3DDevice->SetTextureStageState(1, D3DTSS_ALPHAOP,  D3DTOP_ADD);
	pD3DDevice->SetTextureStageState(1, D3DTSS_ALPHAARG1,D3DTA_CURRENT );
	pD3DDevice->SetTextureStageState(1, D3DTSS_ALPHAARG2,D3DTA_SPECULAR);

	pD3DDevice->SetTextureStageState(2, D3DTSS_ALPHAOP,  D3DTOP_DISABLE );

	//             0xaarrggbb
	DWORD colmul = 0xff000000;
	DWORD coladd = 0x00000000;
	

	float scale = 255;
	colmul = D3DCOLOR_ARGB((int)(mula*scale),(int)(mulr*scale),(int)(mulg*scale),(int)(mulb*scale));

	coladd = D3DCOLOR_ARGB(adda,addr,addg,addb);

	TVERTEX* Vertex = new TVERTEX[NumPoints];

	for (int i=0; i<NumPoints; i++)
	{
		Vertex[i].x=pPoints[i].x;
		Vertex[i].y=pPoints[i].y;
		Vertex[i].z=0;
		Vertex[i].rhw=1;
		Vertex[i].tu=pTexPoints[i].x;
		Vertex[i].tv=pTexPoints[i].y;

		Vertex[i].colmul = colmul;
		Vertex[i].coladd = coladd;

	}

	pD3DDevice->SetRenderState(D3DRS_CULLMODE, D3DCULL_NONE);

	pD3DDevice->SetTexture( 0, pTex );
	pD3DDevice->SetVertexShader( TVERTEX::FVF_TVERTEX );
	pD3DDevice->DrawPrimitiveUP( D3DPT_TRIANGLEFAN, NumPoints-1, Vertex, sizeof( TVERTEX ) );
	
	delete[] Vertex;

	pD3DDevice->SetTextureStageState(0, D3DTSS_ALPHAOP,  D3DTOP_DISABLE );
	pD3DDevice->SetTextureStageState(1, D3DTSS_ALPHAOP,  D3DTOP_DISABLE );
	pD3DDevice->SetTextureStageState(2, D3DTSS_ALPHAOP,  D3DTOP_DISABLE );
	pD3DDevice->SetTexture(0, NULL);
}


inline void DebugDrawLineList2D(IDirect3DDevice8* pD3DDevice, D3DXVECTOR2* pPoints, int NumPoints)
{
	struct VERTEX
	{
		float x,y,z,rhw;
		unsigned int rgba;
		enum { FVF_VERTEX = D3DFVF_XYZRHW | D3DFVF_DIFFUSE };
	};

	pD3DDevice->SetTextureStageState(0,D3DTSS_COLOROP,	D3DTOP_SELECTARG1);
	pD3DDevice->SetTextureStageState(0,D3DTSS_COLORARG1,	D3DTA_DIFFUSE);

	VERTEX* Vertex = new VERTEX[NumPoints];
	for (int i=0; i<NumPoints; i++)
	{
		Vertex[i].x=pPoints[i].x;
		Vertex[i].y=pPoints[i].y;
		Vertex[i].z=0;
		Vertex[i].rhw=1;
		Vertex[i].rgba=0xff00ffff;
	}

	pD3DDevice->SetTexture( 0, NULL );
	pD3DDevice->SetVertexShader( VERTEX::FVF_VERTEX );
	pD3DDevice->DrawPrimitiveUP( D3DPT_LINESTRIP, NumPoints-1, Vertex, sizeof( VERTEX ) );
	
	delete[] Vertex;
}