/******************************************************************************/
/*                                                                            */
/*  File: main.cpp                                                            */
/*  Author: bkenwright@xbdev.net                                              */
/*  URL: www.xbdev.net                                                        */
/*                                                                            */
/******************************************************************************/
/*
	flash parser/drawer tutorial/demo
*/
/******************************************************************************/

// zlib decompression dll references:
// ref: http://www.gzip.org/zlib/

// http://edais.mvps.org/Tutorials/ZLib/index.html

// Enable memory leak checking, you never know, little leaks sometimes sneak
// through, and this will let us know if one has
#define _CRTDBG_MAP_ALLOC
#include <stdlib.h>
#include <crtdbg.h>


#include <windows.h>

#pragma comment(lib, "D3d8.lib")
#pragma comment(lib, "D3dx8.lib")
#include <d3dx8.h>

#include "swfdraw.h"


LPDIRECT3D8			g_pD3D			= NULL;
LPDIRECT3DDEVICE8	g_pD3DDevice	= NULL;
HWND				g_hWnd			= NULL;
SWFDraw				g_swfDraw;
float				g_timeStep		= 0.0f;

//------------------------------------------------------------------------------

bool CreateDX()
{
	g_pD3D = Direct3DCreate8(D3D_SDK_VERSION);
	D3DDISPLAYMODE d3ddm;
	g_pD3D->GetAdapterDisplayMode(D3DADAPTER_DEFAULT, &d3ddm);


	D3DPRESENT_PARAMETERS d3dpp; 
	ZeroMemory(&d3dpp, sizeof(d3dpp));

	d3dpp.Windowed = TRUE;
	d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
	d3dpp.BackBufferFormat = d3ddm.Format;
	d3dpp.BackBufferCount=1;
	d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
	d3dpp.EnableAutoDepthStencil = TRUE;

	HRESULT hr =
	g_pD3D->CreateDevice(	D3DADAPTER_DEFAULT, 
							D3DDEVTYPE_HAL,
							g_hWnd, 
							D3DCREATE_SOFTWARE_VERTEXPROCESSING, 
							&d3dpp, 
							&g_pD3DDevice);

	// If the graphics card doesn't support hardware acceleration
	if (hr!=S_OK)
	{
		g_pD3D->CreateDevice(	D3DADAPTER_DEFAULT, 
								D3DDEVTYPE_REF,
								g_hWnd, 
								D3DCREATE_SOFTWARE_VERTEXPROCESSING, 
								&d3dpp, 
								&g_pD3DDevice);
	}

	g_pD3DDevice->SetRenderState(D3DRS_LIGHTING, FALSE);

	g_pD3DDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE); 
	//g_pD3DDevice->SetRenderState(D3DRS_ALPHAFUNC, D3DCMP_GREATEREQUAL); 
	//g_pD3DDevice->SetRenderState(D3DRS_ALPHAREF, (DWORD)8); 
	//g_pD3DDevice->SetRenderState(D3DRS_ALPHATESTENABLE, TRUE);

	g_pD3DDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
	g_pD3DDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);

	dprintf(" " );

	return true;
}// End CreateDX()

bool ReleaseDX()
{
	g_pD3DDevice->Release();
	g_pD3DDevice = NULL;

	g_pD3D->Release();
	g_pD3D = NULL;
	return true;
}// End ReleaseDX()

void GameLoopDX()
{
	if(!g_pD3DDevice)return;

	// We use a more accurate timing information, QueryPerformanceCounter
	// instead of GetTickCount() so we get smoother animations
	LARGE_INTEGER freq;
	QueryPerformanceFrequency(&freq);

	LARGE_INTEGER nTime;
	QueryPerformanceCounter(&nTime);

	static LARGE_INTEGER oTime = nTime;

	double delay = (double(nTime.QuadPart - oTime.QuadPart)/freq.QuadPart);
	oTime=nTime;

	g_timeStep = (float)delay;

	if (g_timeStep > 0.2f)
	{
		g_timeStep = 0.2f;
	}

	static float updateFPS = 0.0f;
	updateFPS += (float)delay;
	static float fps = 1.0f/(float)delay;
	if (updateFPS>1.0f)
	{
		updateFPS=0.0f;
		fps = 1.0f/(float)delay;
	}

	extern HWND g_hWnd;
	static char title[256] = {0};
	sprintf(title, "Flash SWF - www.xbdev.net - Parser/Drawer - FPS:%.1f,  TimeStep:%.2f", fps, g_timeStep);
	SetWindowText(g_hWnd, title);

	g_pD3DDevice->BeginScene();

	g_pD3DDevice->Clear(	0, 
							NULL, 
							D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER, 
							D3DCOLOR_XRGB(0,0,0), 1.0f, 0 );

	/*
	static bool doneAmbient = false;
	if (g_swfDraw.DonePlay() && (doneAmbient==false))
	{
		doneAmbient=true;
		g_swfDraw.Select(g_pD3DDevice, "NtoN_start", "NtoN_end", true); 
	}
	else
	{
		static float wait = 10.0f;
		wait -= g_timeStep;

		static bool doneOutro = false;
		if (wait < 0.0f && (doneOutro==false))
		{
			doneOutro=true;
			g_swfDraw.Select(g_pD3DDevice, "NtoO_start", "NtoO_end", false);
		}
	}
	*/


	g_swfDraw.Render(g_pD3DDevice);

	g_pD3DDevice->EndScene();
	g_pD3DDevice->Present( NULL, NULL, NULL, NULL );
}// End GameLoopDX()

//------------------------------------------------------------------------------

long _stdcall MsgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
		case WM_KEYDOWN:
		{
			switch( wParam )
			{
				case VK_ESCAPE:         // Exit on pressing Escape Key
					PostQuitMessage(0);
					break;
			}
		}
		break;

		case WM_DESTROY:
		{
			PostQuitMessage(0);
		}
		break;
	}

    return (long)DefWindowProc(hWnd, uMsg, wParam, lParam);
}// End MsgProc(..)


//------------------------------------------------------------------------------

// msvcrt.lib

int _stdcall WinMain(HINSTANCE i, HINSTANCE j, char* k, int) 
{
	// Turn on memory leak checking
	_CrtSetDbgFlag(_CrtSetDbgFlag(_CRTDBG_REPORT_FLAG)|_CRTDBG_LEAK_CHECK_DF);

	MSG msg;
	char szname[] = "Flash SWF - www.xbdev.net - Parser/Drawer";
    WNDCLASSEX wc = {	sizeof(WNDCLASSEX), CS_CLASSDC, MsgProc, 0L, 0L, 
						GetModuleHandle(NULL), NULL, NULL, NULL, NULL,
						szname, NULL };
						RegisterClassEx( &wc );
	g_hWnd = CreateWindowEx(	WS_EX_APPWINDOW,
								szname, szname, 
								WS_OVERLAPPEDWINDOW,
								//50, 50, 1000,700,
								//60, 1000, 100,100,
								100, 100, 640,480,
								GetDesktopWindow(), NULL, wc.hInstance, NULL);


	CreateDX();
	IDirect3DDevice8* pd = g_pD3DDevice;

	//g_swfDraw.Create(pd, "media\\smilebiotween.swf");
	//g_swfDraw.Create(pd, "media\\dialogsimple.swf");
	//g_swfDraw.Create(pd, "media\\test2.swf");
	//g_swfDraw.Create(pd, "media\\smileyscaling.swf");
	//g_swfDraw.Create(pd, "media\\smiley.swf");
	//g_swfDraw.Create(pd, "media\\smileytexture.swf");
	//g_swfDraw.Create(pd, "media\\dialog.swf");
	//g_swfDraw.Create(pd, "media\\simple.swf");
	//g_swfDraw.Create(pd, "media\\smileytweening.swf");
	g_swfDraw.Create(pd, "media\\explode.swf");
	//g_swfDraw.Create(pd, "media\\rotate.swf");
	//g_swfDraw.Create(pd, "media\\321_pimp.swf");
	//g_swfDraw.Create(pd, "media\\3.swf");
	//g_swfDraw.Create(pd, "media\\fade.swf");
	//g_swfDraw.Create(pd, "media\\dialogother.swf");

	ShowWindow(g_hWnd, SW_SHOW);
	UpdateWindow(g_hWnd);

	//g_swfDraw.Select(g_pD3DDevice, "OtoN_start", "OtoN_end", false); 

	while(1)
	{
		if (PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE))
		{
			if (!GetMessage(&msg, NULL, 0, 0))
				break;
			DispatchMessage(&msg);
        }
		else
		{
			GameLoopDX();
		}
	}

	g_swfDraw.Release();
	ReleaseDX();

	_CrtDumpMemoryLeaks();

}// End WinMain(..)


//------------------------------------------------------------------------------

















