/******************************************************************************/
/*                                                                            */
/*  File: swfdraw.h                                                           */
/*  Author: bkenwright@xbdev.net                                              */
/*  Date: 19-01-06                                                            */
/*                                                                            */
/******************************************************************************/
/*
*/
/******************************************************************************/

#ifndef SWFDRAW_H
#define SWFDRAW_H

#include "swf.h"
#include "swftextures.h"

#define MAX_CHILD		500

#define MAX_TEXTURES	200


/******************************************************************************/

class SWFSpriteObj
{
public:
	SWFSpriteObj();
	~SWFSpriteObj();

	static int			s_obj;
	static stSWF*		m_swf;
	static SWFTextures	s_texlist[MAX_TEXTURES];
	static int			s_numtex;

	void Create(int cID, stSWFTags* tag, D3DXMATRIX mat, int depth, stCXForm tc);
	void Release();
	void Render(IDirect3DDevice8* pD3DDevice, D3DXMATRIX* mat, int depth, stCXForm* tc);
	void Update(IDirect3DDevice8* pD3DDevice);

	void Select(IDirect3DDevice8* pD3DDevice, int startIndx, int endIndx, bool loop);
	bool DonePlay(){return m_donePlay;}

protected:
	void ShowFrame(IDirect3DDevice8* pD3DDevice);
	void ReleaseAllObjects();

	void DoTag				(IDirect3DDevice8* pD3DDevice, D3DXMATRIX* mat, stSWFTags* tag, int depth=-1, stCXForm* tc=NULL);
	void DoDefineShape		(IDirect3DDevice8* pD3DDevice, D3DXMATRIX* mat, stDefineShape* ds, int depth,  stCXForm* tc);
	void DoDefineSprite		(IDirect3DDevice8* pD3DDevice, D3DXMATRIX* mat, stDefineSprite* ds, int depth,  stCXForm* tc);
	void DoPlaceObject2		(IDirect3DDevice8* pD3DDevice, stPlaceObject2* ds);
	void DoRemoveObject2	(IDirect3DDevice8* pD3DDevice, stRemoveObject2* ds);


protected:
	int					m_cID;
	D3DXMATRIX			m_mat;
	SWFSpriteObj*		m_child[MAX_CHILD];
	int					m_depth;
	stCXForm			m_cxForm;
	
	// Draw Object
	bool				m_draw;
	bool				m_active;
	D3DXVECTOR3			m_verts[50];
	D3DXVECTOR2 		m_texcoords[50];
	int					m_numVerts;
	int					m_texID;

	// Frame Count
	stSWFTags*			m_tags;
	int					m_frame;
	int					m_startIndx;;
	int					m_endIndx;;
	int					m_loop;
	int					m_numTags;
	bool				m_donePlay;
};

/******************************************************************************/


class SWFDraw
{
public:
	SWFDraw();
	~SWFDraw(){Release();};

	bool	Create(IDirect3DDevice8* pD3DDevice, char* szFileName);
	bool	Release();
	void	Render(IDirect3DDevice8* pD3DDevice);

	bool	Select(IDirect3DDevice8* pD3DDevice, char* startLabel, char* endLabel, bool loop);
	bool	DonePlay(){return m_obj.DonePlay();};
protected:
	bool	LoadAllTextures(IDirect3DDevice8* pD3DDevice);
	int		FindFrame(char* labelname);

	stSWF*			m_swf;
	SWFSpriteObj	m_obj;
};




#endif //SWFDRAW_H