/******************************************************************************/
/*                                                                            */
/*  File: swftextures.h                                                       */
/*  Author: bkenwright@xbdev.net                                              */
/*  Date: 19-01-06                                                            */
/*                                                                            */
/******************************************************************************/
/*
*/
/******************************************************************************/

#ifndef SWFTEXTURES_H
#define SWFTEXTURES_H

#pragma comment(lib, "D3d8.lib")
#pragma comment(lib, "D3dx8.lib")
#include <d3dx8.h>


class SWFTextures
{
public:
	IDirect3DTexture8* m_texture;
	int				   m_width;
	int				   m_height;
	int				   m_cID;

public:
	SWFTextures()
	{
		m_texture=NULL;
		Release();
	}
	~SWFTextures()	{Release();}

	bool Create(IDirect3DDevice8*pD3DDevice, char*rgba, int iw, int ih, int cID)
	{
		Release();

		m_width		= iw;
		m_height	= ih;
		m_cID		= cID;

		HRESULT hr = 
		pD3DDevice->CreateTexture(	iw, 
									ih, 
									1,
									0, //D3DUSAGE_DYNAMIC, // Usage flag
									D3DFMT_A8R8G8B8,
									//D3DPOOL_DEFAULT, 
									//D3DPOOL_SYSTEMMEM,
									D3DPOOL_MANAGED,
									&m_texture );

		D3DSURFACE_DESC desc;
		m_texture->GetLevelDesc (0, &desc);

		D3DLOCKED_RECT rect;
		hr = 
		m_texture->LockRect (0, &rect, 0, D3DLOCK_NOSYSLOCK);
		

		for (int y=0; y< (int)desc.Height; y++)
		{
			for(int x =0; x < (int)desc.Width; x++)
			{
				DWORD* pixel = ((DWORD*) (((BYTE*) rect.pBits) +rect. Pitch*y+x*sizeof (DWORD)));

				int i = (x + (iw)*y) * 4;
				
				unsigned char cr = rgba[i + 3];
				unsigned char cg = rgba[i + 2];
				unsigned char cb = rgba[i + 1];
				unsigned char ca = rgba[i + 0];			

				DWORD colour = (ca<<24)|(cr<<16)|(cg<<8)|(cb<<0);

				*pixel = colour;

			}
		}

		m_texture->UnlockRect (0);	
		return true;
	}// End Create(..)

	void Release()
	{
		if (m_texture)
		{
			m_texture->Release();
			m_texture=NULL;
		}
		m_width=0;
		m_height=0;
		m_cID=-1;
	}// End Release()
	
};



#endif //SWFTEXTURES_H



